
import pt.gov.cartaodecidadao.*;
import static pt.gov.cartaodecidadao.PTEID_Param.PTEID_PARAM_XSIGN_TIMEOUT;
import static pt.gov.cartaodecidadao.PTEID_Param.PTEID_PARAM_XSIGN_TSAURL;
import static pt.gov.cartaodecidadao.pteidlibJava_WrapperConstants.*;

public class SignXADES {

	private static PTEID_ReaderContext readerContext = null;
	private static PTEID_ReaderSet readerSet = null;
	private static PTEID_EIDCard idCard = null;

	static void init() throws PTEID_Exception {
		System.loadLibrary("pteidlibj");

		PTEID_ReaderSet.initSDK();
		readerSet = PTEID_ReaderSet.instance();
		readerContext = readerSet.getReader();
		pteidlibJava_Wrapper.setCompatReaderContext(readerContext);
		idCard = readerContext.getEIDCard();
		idCard.doSODCheck(false);
		PTEID_Config config = new PTEID_Config(PTEID_PARAM_XSIGN_TSAURL);
		config.setString("http://sha256timestamp.ws.symantec.com/sha256/timestamp"); // using a third party TSA

	}

	public static void main(String[] args) throws Exception {
		try {
		init();

		String output = args[0]+ ".zip";
		String [] files = new String[] {args[0]};

		idCard.SignXades(output, files, files.length);
		} 
		catch(PTEID_Exception e) {
			System.err.println(String.format("Caught error in SDK method: %08x", e.GetError()));
		}


		try {
			PTEID_ReaderSet.releaseSDK();
		} catch (PTEID_Exception e) {
			e.printStackTrace();
		}

	}

}